
	section	.data

LC0	dc.b	074h,072h,06Bh,06Ch,06Fh,067h,000h

	align	1	; ASM_OUTPUT_ASCII

	section	.text
	align	1
_partition
	pshm	z
	tsz

	tdx	
	ldy	#_parts

L2	cpe	2,y
	bhs	L5
	
	asle	
	asle	
	asle	
	ste	0,x
	ldd	0,y
	bra	L1
	

L5	sube	2,y
	xgdy	
	addd	#4
	xgdy	
	cpy	#_parts+32
	blo	L2
	
	lde	#LC0
	jsr	_doh

L1	pulm	z
	rts

	align	1
_read
	pshm	z
	ais	#-12
	tsz

	tey	
	std	4,z
	tze	
	aie	#2
	ste	8,z
	tye	
	ldd	8,z
	jsr	_partition
	std	6,z
	clrw	10,z
	ord	#-32768
	lde	#2
	ste	0,z
	tde	
	ldd	8,z
	jsr	_i2c_wr
	tstb	
	beq	L8
	
	lde	18,z
	ste	0,z
	lde	6,z
	ldd	4,z
	jsr	_i2c_rd
	tstb	
	beq	L8
	
	lde	#1
	ste	10,z

L8	ldd	10,z

	ais	#+12
	pulm	z
	rts

	align	1
_write
	pshm	z
	ais	#-10
	tsz

	tey	
	std	4,z
	tze	
	aie	#2
	ste	6,z
	tye	
	ldd	6,z
	jsr	_partition
	clrw	8,z
	ord	#-32768
	lde	#2
	ste	0,z
	tde	
	ldd	6,z
	jsr	_i2c_wr
	tstb	
	beq	L10
	
	lde	16,z
	ste	0,z
	clre	
	ldd	4,z
	jsr	_i2c_wr
	tstb	
	beq	L10
	
	lde	#1
	ste	8,z

L10	ldd	8,z

	ais	#+10
	pulm	z
	rts

	align	1
_init
	pshm	z
	ais	#-24
	tsz

	ldd	#160
	std	14,z

L15	ldx	14,z
	stx	_parts
	ldd	#1
	std	_parts+2
	ldx	#12
	stx	0,z
	clre	
	tzd	
	aid	#2
	jsr	_read
	stab	18,z
	lbeq	L24
	
	lde	4,z
	cpe	#7653
	lbne	L24
	
	tzx	
	xgdx	
	addd	#6
	xgdx	
	stx	16,z
	ldy	#_parts
	cpy	#_parts+32
	lbhs	L18
	

L20	ldx	16,z
	ldab	0,x
	clra	
	std	20,z
	incw	16,z
	lde	20,z
	ande	#15
	ore	#160
	ste	22,z
	andd	#240
	asld	
	asld	
	asld	
	asld	
	asld	
	std	20,z
	bne	L21
	
	ldd	#8192
	std	20,z

L21	ldd	20,z
	cpd	#2047
	bls	L24
	
	lde	22,z
	ande	#1
	bne	L24
	
	ldd	22,z
	std	0,y
	ldd	20,z
	std	2,y
	lde	20,z
	adde	_slots
	ste	_slots
	xgdy	
	addd	#4
	xgdy	
	cpy	#_parts+32
	lblo	L20
	

L18	lde	_slots
	cpe	#2
	bls	L24
	
	ldx	2,z
	stx	_ix
	ldd	#1
	bra	L28
	

L24	clrw	_slots
	ldd	14,z
	aid	#2
	std	14,z
	cpd	#174
	lbls	L15
	
	clrd	

L28
	ais	#+24
	pulm	z
	rts

	align	1

	global	_trklog
_trklog
	pshm	z
	ais	#-16
	tsz

	ste	14,z
	tstw	_slots
	bne	L31
	
	jsr	_init
	tstb	
	lbeq	L30
	

L31	lde	_ix
	cpe	_slots
	bhs	L33
	
	cpe	#1
	bhi	L32
	

L33	ldy	#2
	sty	_ix

L32	ldy	14,z
	ldy	0,y
	sty	2,z
	ldy	14,z
	ldy	2,y
	sty	4,z
	ldy	14,z
	ldy	4,y
	sty	6,z
	ldy	14,z
	ldy	6,y
	sty	8,z
	lde	_ix
	ted	
	aie	#1
	ste	_ix
	ldy	#8
	sty	0,z
	tde	
	tzd	
	aid	#2
	jsr	_write
	tstb	
	beq	L30
	
	tze	
	aie	#10
	jsr	_now

L35	ldy	#2
	sty	0,z
	clre	
	ldd	#_ix
	jsr	_write
	tstb	
	bne	L29
	
	tze	
	aie	#10
	jsr	_time_since
	cpd	#10
	bls	L35
	

L30	clrw	_slots

L29
	ais	#+16
	pulm	z
	rts


	section	.bss
_parts
	ds.b	32
_slots
	ds.b	2
_ix
	ds.b	2


	end
